import urllib2
import zipfile
import os
import subprocess
import sys
import platform
import codecs


def downloadAndExtractZip(url, zipName, destination):
    print "Download file: {url}/{zipName}".format(url=url, zipName=zipName)
    fileToDownload = urllib2.urlopen(
        "{url}/{zipName}".format(url=url, zipName=zipName))
    with open(zipName, 'wb') as output:
        output.write(fileToDownload.read())
    with zipfile.ZipFile(zipName, 'r') as zip_ref:
        zip_ref.extractall(destination)

def convertImagesInFolder(path):
    paths_with_images = [
        os.path.join(path, r"[4YouSee] default_project", "data-source"),
        os.path.join(path, r"[4YouSee] default_project", "imgnew"),
        os.path.join(path, r"[4YouSee] default_project", "layout", "imgnew"),
        os.path.join(path, r"[4YouSee] default_project", "media"),
    ]
    for root, dirs, files in os.walk(path):
        if root in paths_with_images:
            for currentFile in files:
                exts = ('.png', '.jpg', '.jpeg' )
                if currentFile.lower().endswith(exts):
                    cmd = '.\\convertImages\\exiftool.exe -ICC_Profile= "{file}"'.format(file=os.path.join(root, currentFile))
                    proc = subprocess.Popen(cmd, shell=True, stdout=subprocess.PIPE)
                    (output, error) = proc.communicate()
                    proc.wait()


if __name__ == "__main__":
    architecture = platform.architecture()[0]
    dist = '32'
    if architecture == '64bit':
        dist = '64'
    downloadAndExtractZip(
        "https://4yousee-static.s3.amazonaws.com/files/players/scripts", "4youseeConvert.zip", "./convertImages")
    downloadAndExtractZip("https://4yousee-static.s3.amazonaws.com/files/players/scripts",
                          "files_{dist}.zip".format(dist=dist), "convertImages")
    path_player_files = raw_input(
        "Digite o path da pasta onde sao salvos os arquivos do player: ").decode(sys.stdin.encoding)
    if path_player_files is not None or path_player_files:
        with codecs.open(r'convertImages\\.env.sample') as infile, codecs.open(r'convertImages\\.env', 'w') as outfile:
            for line in infile:
                if line.strip() == 'PATH_FILES_PLAYER=""':
                    line = u'PATH_FILES_PLAYER="{path_player_files}"\n'.format(
                        path_player_files=path_player_files).encode('utf-8').replace('\\', '\\\\')
                outfile.write(line)
        os.remove(r'convertImages\\.env.sample')
        convertImagesInFolder(path_player_files)
    else:
        os.rename(r'convertImages\\.env.sample', r'convertImages\\.env')

    response = subprocess.check_call(
        [sys.executable, "-m", "pip", "install", "-r",
            "convertImages/Requirements.txt"]
    )
    if response == 0:
        print "Script was installed"
    else:
        print "Unable to install libs"
